// <editor-fold defaultstate="collapsed" desc="comment">
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.uniheidelberg.cl.rituals.wsd;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;

import org.eml.MMAX2.core.Config;

import edu.mit.jwi.Dictionary;
import edu.mit.jwi.IDictionary;
import edu.mit.jwi.item.IIndexWord;
import edu.mit.jwi.item.IWordID;
import edu.mit.jwi.item.POS;
import edu.mit.jwi.item.SynsetID;

/**
 *
 * @author rodrig
 */
public class CheckWord {

	private static CheckWord instance;
	
	
	private CheckWord() {}
	
	public static CheckWord getInstance() {
		if (instance == null) {
			instance = new CheckWord();
		}
		return instance;
	}
	
	
    private IDictionary initialize() {
    	Config c = null;
    	try {
			c = Config.getInstance();
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
    	
        String wnhome = c.getWnDir(); 

        String path = wnhome + File.separator + "dict";
        URL url = null;
        try {
            url = new URL("file", null, path);
        } catch (MalformedURLException e) {
        }
        //if(url == null) return;

        IDictionary dict = new Dictionary(url);
        //dict.open();
        return dict;
    }

    public ArrayList check(String word, char pos) {
        IDictionary dict = initialize();
        dict.open();
        ArrayList<String> results = new ArrayList();
        IIndexWord idxWord = dict.getIndexWord(word, POS.getPartOfSpeech(pos));
        
        /* Returns an iterator over possible word senses.
         * Throws a NPE if no sense is found. */
        try {
        	
	        
	        Iterator<IWordID> it = idxWord.getWordIDs().iterator();
	
	        while (it.hasNext()) {
	            String op = new String();
	            IWordID senses = it.next();
	            String sensesString = senses.toString();
	            int senseId = new Integer(sensesString.split("-")[1].trim()).intValue();
	            String senseIdString = sensesString.split("-")[1].trim();
	            SynsetID sID = new SynsetID(senseId, POS.getPartOfSpeech(pos));
	            SuperSense sp = new SuperSense();
	
	            op += senseIdString+"-"+pos+" | ";
	            op += sp.get_supersenses(word, senseIdString+"-"+pos)+" | ";
	            op += dict.getSynset(sID).getGloss();
	            results.add(op);
	        }
        } catch (NullPointerException e) {
        	System.err.println("No sense found for word '" + word + "'");
        	return null;
        }
	        
        return results;
    }
}
