package de.uniheidelberg.cl.rituals.wsd;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

import org.eml.MMAX2.core.Config;

import edu.mit.jwi.Dictionary;
import edu.mit.jwi.IDictionary;
import edu.mit.jwi.item.IIndexWord;
import edu.mit.jwi.item.IWord;
import edu.mit.jwi.item.IWordID;
import edu.mit.jwi.item.POS;


public class SuperSense {

	/**
	 * @param args
	 */
	public IDictionary wn_dict() {
		// construct the URL to the Wordnet dictionary directory
		Config c = null;
    	try {
			c = Config.getInstance();
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
    	
        String wnhome = c.getWnDir(); 

        String path = wnhome + File.separator + "dict";
		URL url = null;
		try{ url = new URL("file", null, path); } 
		catch(MalformedURLException e){ e.printStackTrace(); }
		if(url == null) return null;

		IDictionary dict = new Dictionary(url);
		dict.open();
		return dict;
	}
	
	public String get_supersenses(String word, String senseId) {
		
		IDictionary dict = wn_dict();
		char pos = senseId.split("-")[1].charAt(0);
		String senseNumber = senseId.split("-")[0];
		String superSense = null;
		
		//get the synset
		IIndexWord idxWord = dict.getIndexWord(word, POS.getPartOfSpeech(pos));
		
		List<IWordID> ids = idxWord.getWordIDs();
		
		for (IWordID id : ids) {
			String tempSenseId = id.getSynsetID().toString().split("-")[1];
			if (tempSenseId.equals(senseNumber)) {
				IWord w = dict.getWord(id);
				superSense = w.getSynset().getLexicalFile().getName();
				
				//System.out.println(id.getSynsetID());
				//System.out.println(w.getSynset().getLexicalFile().getName());
				//System.out.println(w.getSynset().getGloss());
			}
		}
		if (superSense == null) {
			return "!NOT.FOUND!";
		} else
			return superSense;
	}
	
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SuperSense sp = new SuperSense();
		//example:
		//System.out.println(sp.get_supersenses("dog", "02001223-n"));
	}
}
